/*
v 1.1
AI 10

 GrayScale   CMYK.
( Black   GrayScale)

    CMYK. 
      ,
      var max = ;
( -  )
     PathItems    
   GrayScale Color
   Gradient Color
   CMYK Color

 Fill & Stroke    
 overprint     Spots   tint=0.
     .
  -   ,
   ,    selected 
      .

 Gradient Color   First gradient stop=0 and Last gradient stop=100
(    ,     )
    First gradient stop<2     0
    Last gradient stop>98     100
       First gradient stop=0  Last gradient stop=100
   


regards
Eduard Kolenov
mailto:ed@macbox.ru
*/

//$.bp()

var doc = activeDocument;
//var pgItems = doc.pageItems;
var pthItems = doc.pathItems;
//var ComPthItems = doc.CompoundPathItems;
var min = 1.26; //  
var max = 2;   //  
var Clr = 0;

if (documents.length > 0){
if (pthItems.length>0){
	for(i=0;i<pthItems.length;i++){
		if (pthItems[i].editable){engine(pthItems[i]);}
	}
}
}
alert('   ::::::: Complete! :::::::   ');

////////////////////////////////////////////////////////////////////
//                                                     //
////////////////////////////////////////////////////////////////////
function engine (obj){
	if (obj.filled) {ChColor(obj.fillColor);}
            if (obj.fillOverprint){
               try {OverprintWhite(obj.fillColor);}
               catch (e){obj.selected=true;}
            }
            if (Clr==1) {obj.fillOverprint=false;}
            
            if (obj.stroked) {ChColor(obj.strokeColor);}
            if (obj.strokeOverprint){
               try {OverprintWhite(obj.strokeColor);}
               catch (e){obj.selected=true;}
            }
            if (Clr==1) {obj.strokeOverprint=false;}
}


function ChColor(ColOfObj){  //  +  + 
   switch(ColOfObj.color){
   case 1: CMYK(ColOfObj); break;
   case 2: Gray(ColOfObj); break;
   case 6: Grad(ColOfObj); break;
   }
}

function CMYK(ColOfObj){
   var GetColor_Obj = new CMYKColor();
   GetColor_Obj = ColOfObj.cmyk;
   GetBlack = GetColor_Obj.black;
   GetCyan = GetColor_Obj.cyan;
   GetMagenta = GetColor_Obj.magenta;
   GetYellow = GetColor_Obj.yellow;
   
   //-----Black------------------------
   if ((GetBlack>=0)&&(GetBlack<=min)) {SetBlack = 0;}
   else if ((GetBlack>min)&&(GetBlack<=max)) {SetBlack = max;}
   else{SetBlack = GetBlack;}
   //----Cyan-----------------------
   if ((GetCyan>=0)&&(GetCyan<=min)) {SetCyan = 0;}
   else if ((GetCyan>min)&&(GetCyan<=max)) {SetCyan = max;}
   else{SetCyan = GetCyan;}
   //-----Magenta-----------------------
   if ((GetMagenta>=0)&&(GetMagenta<=min)) {SetMagenta = 0;}
   else if ((GetMagenta>min)&&(GetMagenta<=max)) {SetMagenta = max;}
   else{SetMagenta = GetMagenta;}
   //-----Yellow---------------------
   if ((GetYellow>=0)&&(GetYellow<=min)) {SetYellow = 0;}
   else if ((GetYellow>min)&&(GetYellow<=max)) {SetYellow = max;}
   else{SetYellow = GetYellow;}

   var SetColor_Obj = new CMYKColor();
   SetColor_Obj = ColOfObj.cmyk;
   SetColor_Obj.black = SetBlack;
   SetColor_Obj.cyan = SetCyan;
   SetColor_Obj.magenta = SetMagenta;
   SetColor_Obj.yellow = SetYellow;
   return SetColor_Obj;
}

function Gray(ColOfObj){
   var GetColor_Obj = new GrayColor();
   GetColor_Obj = ColOfObj.gray;
   var NewColor_Obj = new CMYKColor();
   NewColor_Obj.black = GetColor_Obj.gray;
   NewColor_Obj.cyan = 0;
   NewColor_Obj.magenta = 0;
   NewColor_Obj.yellow = 0;
   var SetColor = new Color();
   SetColor.cmyk = NewColor_Obj;
   ColOfObj.cmyk = SetColor.cmyk;
}

function Grad(ColOfObj)
{
   var GetGradient =  ColOfObj.gradient;
   var SetGradient = GetGradient.gradient;
   var StopGradient = SetGradient.gradientStops;
   var countStops = StopGradient.length;
   var StopsRP = new Array();
   var StopsColor = new Array();
   var StopsMP = new Array();

for (g=0;g<countStops;g++){
   ColStop = StopGradient[g].color;
   ColStop = ChColor(ColStop);
   
//save the properties of stops to arrays
   StopsRP[g] = StopGradient[g].rampPoint;
   StopsMP[g] = StopGradient[g].midPoint;
   StopsColor[g] = StopGradient[g].color;
}  

if (StopGradient[0].rampPoint < 2){
	var deltaMPStart = StopGradient[0].rampPoint;
	StopGradient[0].rampPoint = 0;
	//StopGradient[0].midPoint+= deltaMPStart*2;
}
if (StopGradient[countStops-1].rampPoint > 98){
	var deltaMPEnd = eval(100-StopGradient[countStops-1].rampPoint);
	StopGradient[countStops-1].rampPoint = 100;
	//StopGradient[countStops-2].midPoint-= deltaMPEnd*2;
   	}
	   
if (StopGradient[0].rampPoint !=0 && StopGradient[countStops-1].rampPoint !=100){
 // Modify the first gradient stop
 StopGradient[0].rampPoint = 0;
 for (g=1;g<countStops;g++){
  StopGradient[g].rampPoint = StopsRP[g-1];
  StopGradient[g].midPoint = StopsMP[g-1];
  StopGradient[g].color = StopsColor[g-1];
 } 
   // add the new gradient stop
  newGradientStop = StopGradient.add();
  newGradientStop.rampPoint = StopsRP[countStops-1];
  newGradientStop.color = StopsColor[countStops-1];
  newGradientStop = StopGradient.add();
  newGradientStop.rampPoint = 100;
  newGradientStop.color = StopsColor[countStops-1];
}
 
else if (StopGradient[0].rampPoint !=0){
 // Modify the first gradient stop
 StopGradient[0].rampPoint = 0;
  for (g=1;g<countStops;g++){
   StopGradient[g].rampPoint = StopsRP[g-1];
   StopGradient[g].midPoint = StopsMP[g-1];
   StopGradient[g].color = StopsColor[g-1];
  } 
   // add the new gradient stop
   newGradientStop = StopGradient.add();
   newGradientStop.rampPoint = 100;
   newGradientStop.color = StopsColor[countStops-1];
}
 
else if (StopGradient[countStops-1].rampPoint !=100){
 // add the new gradient stop
 newGradientStop = StopGradient.add();
 newGradientStop.rampPoint = 100;
 newGradientStop.color = StopsColor[countStops-1];
}
}

function OverprintWhite(ColOfObj){
 switch(ColOfObj.color){
  case 1:
   var newColor_Obj = new CMYKColor();
   newColor_Obj = ColOfObj.cmyk;
   objBlack = newColor_Obj.black;
   objCyan = newColor_Obj.cyan;
   objMagenta = newColor_Obj.magenta;
   objYellow = newColor_Obj.yellow;
   if (objBlack == 0 && objCyan == 0 && objMagenta == 0 && objYellow == 0) {Clr=1;}
   else  {Clr=0;}
   break;
   
   case 4:
   var newColor_Obj = new SpotColor();
   newColor_Obj = ColOfObj.spot;
   Tint_spot = newColor_Obj.tint;
   if (Tint_spot == 0) {Clr=1;}
   else  {Clr=0;}
   break;
 }
}